#ifndef __TAHITIFPGA_PRIV_H__
#define __TAHITIFPGA_PRIV_H__

#define DRV_NAME        "tahitifpga"

typedef struct platform_fpga_device {
        unsigned long   in_use;
        resource_size_t base;
        void __iomem    *base_addr;
} platform_fpga_device_t;

typedef struct platform_fpga_data {
        uint8_t   fpga_prog_rx;
        uint8_t   fpga_prog_tx;
        uint8_t   fpga_prog_sts;
        uint8_t   fpga_prog_ctl;
        uint8_t   fpga_prog_sel;
        uint16_t  fpga_port0;
        uint16_t  fpga_port1;
        uint8_t   fpga_port_sz;
        uint16_t  fpga_size;
} platform_fpga_data_t;

#define TAHITI_FPGA_PRG_RX      0xD0
#define TAHITI_FPGA_PRG_TX      0xD4
#define TAHITI_FPGA_PRG_STS     0xD8
#define TAHITI_FPGA_PRG_CTL     0xDC
#define TAHITI_FPGA_PRG_SEL     0xE0
#define TAHITI_FPGA_SIZE        0x200

#define TAHITI_FPGA_PORT0       0x700
#define TAHITI_FPGA_PORT1       0x701
#define TAHITI_FPGA_PORT_SIZE   2

#define TAHITI_WD_REG           0x20
#define TAHITI_WD_TIMEOUT_L1    0x24
#define TAHITI_WD_TIMEOUT_L2    0x28

#define TAHITI_WD_EN            0x80
#define TAHITI_WD_KICK          1

#define TAHITI_DEFAULT_TIMEOUT		240 /* 4 minute for L1 during boot */
#define TAHITI_DEFAULT_PRETIMEOUT   	5

extern uint8_t tahiti_fpga_read(uint16_t offset);
extern void tahiti_fpga_write(uint16_t offset, uint8_t data);

#endif /* __TAHITIFPGA_PRIV_H__ */
